git-rebase--interactive.shon commit Update shell scripts to compute empty tree object ID (03a7f38)
   1# This shell script fragment is sourced by git-rebase to implement
   2# its interactive mode.  "git rebase --interactive" makes it easy
   3# to fix up commits in the middle of a series and rearrange commits.
   4#
   5# Copyright (c) 2006 Johannes E. Schindelin
   6#
   7# The original idea comes from Eric W. Biederman, in
   8# https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
   9#
  10# The file containing rebase commands, comments, and empty lines.
  11# This file is created by "git rebase -i" then edited by the user.  As
  12# the lines are processed, they are removed from the front of this
  13# file and written to the tail of $done.
  14todo="$state_dir"/git-rebase-todo
  15
  16# The rebase command lines that have already been processed.  A line
  17# is moved here when it is first handled, before any associated user
  18# actions.
  19done="$state_dir"/done
  20
  21# The commit message that is planned to be used for any changes that
  22# need to be committed following a user interaction.
  23msg="$state_dir"/message
  24
  25# The file into which is accumulated the suggested commit message for
  26# squash/fixup commands.  When the first of a series of squash/fixups
  27# is seen, the file is created and the commit message from the
  28# previous commit and from the first squash/fixup commit are written
  29# to it.  The commit message for each subsequent squash/fixup commit
  30# is appended to the file as it is processed.
  31#
  32# The first line of the file is of the form
  33#     # This is a combination of $count commits.
  34# where $count is the number of commits whose messages have been
  35# written to the file so far (including the initial "pick" commit).
  36# Each time that a commit message is processed, this line is read and
  37# updated.  It is deleted just before the combined commit is made.
  38squash_msg="$state_dir"/message-squash
  39
  40# If the current series of squash/fixups has not yet included a squash
  41# command, then this file exists and holds the commit message of the
  42# original "pick" commit.  (If the series ends without a "squash"
  43# command, then this can be used as the commit message of the combined
  44# commit without opening the editor.)
  45fixup_msg="$state_dir"/message-fixup
  46
  47# $rewritten is the name of a directory containing files for each
  48# commit that is reachable by at least one merge base of $head and
  49# $upstream. They are not necessarily rewritten, but their children
  50# might be.  This ensures that commits on merged, but otherwise
  51# unrelated side branches are left alone. (Think "X" in the man page's
  52# example.)
  53rewritten="$state_dir"/rewritten
  54
  55dropped="$state_dir"/dropped
  56
  57end="$state_dir"/end
  58msgnum="$state_dir"/msgnum
  59
  60# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
  61# GIT_AUTHOR_DATE that will be used for the commit that is currently
  62# being rebased.
  63author_script="$state_dir"/author-script
  64
  65# When an "edit" rebase command is being processed, the SHA1 of the
  66# commit to be edited is recorded in this file.  When "git rebase
  67# --continue" is executed, if there are any staged changes then they
  68# will be amended to the HEAD commit, but only provided the HEAD
  69# commit is still the commit to be edited.  When any other rebase
  70# command is processed, this file is deleted.
  71amend="$state_dir"/amend
  72
  73# For the post-rewrite hook, we make a list of rewritten commits and
  74# their new sha1s.  The rewritten-pending list keeps the sha1s of
  75# commits that have been processed, but not committed yet,
  76# e.g. because they are waiting for a 'squash' command.
  77rewritten_list="$state_dir"/rewritten-list
  78rewritten_pending="$state_dir"/rewritten-pending
  79
  80# Work around Git for Windows' Bash whose "read" does not strip CRLF
  81# and leaves CR at the end instead.
  82cr=$(printf "\015")
  83
  84empty_tree=$(git hash-object -t tree /dev/null)
  85
  86strategy_args=${strategy:+--strategy=$strategy}
  87test -n "$strategy_opts" &&
  88eval '
  89        for strategy_opt in '"$strategy_opts"'
  90        do
  91                strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
  92        done
  93'
  94
  95GIT_CHERRY_PICK_HELP="$resolvemsg"
  96export GIT_CHERRY_PICK_HELP
  97
  98comment_char=$(git config --get core.commentchar 2>/dev/null)
  99case "$comment_char" in
 100'' | auto)
 101        comment_char="#"
 102        ;;
 103?)
 104        ;;
 105*)
 106        comment_char=$(echo "$comment_char" | cut -c1)
 107        ;;
 108esac
 109
 110warn () {
 111        printf '%s\n' "$*" >&2
 112}
 113
 114# Output the commit message for the specified commit.
 115commit_message () {
 116        git cat-file commit "$1" | sed "1,/^$/d"
 117}
 118
 119orig_reflog_action="$GIT_REFLOG_ACTION"
 120
 121comment_for_reflog () {
 122        case "$orig_reflog_action" in
 123        ''|rebase*)
 124                GIT_REFLOG_ACTION="rebase -i ($1)"
 125                export GIT_REFLOG_ACTION
 126                ;;
 127        esac
 128}
 129
 130last_count=
 131mark_action_done () {
 132        sed -e 1q < "$todo" >> "$done"
 133        sed -e 1d < "$todo" >> "$todo".new
 134        mv -f "$todo".new "$todo"
 135        new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
 136        echo $new_count >"$msgnum"
 137        total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
 138        echo $total >"$end"
 139        if test "$last_count" != "$new_count"
 140        then
 141                last_count=$new_count
 142                eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
 143                test -z "$verbose" || echo
 144        fi
 145}
 146
 147# Put the last action marked done at the beginning of the todo list
 148# again. If there has not been an action marked done yet, leave the list of
 149# items on the todo list unchanged.
 150reschedule_last_action () {
 151        tail -n 1 "$done" | cat - "$todo" >"$todo".new
 152        sed -e \$d <"$done" >"$done".new
 153        mv -f "$todo".new "$todo"
 154        mv -f "$done".new "$done"
 155}
 156
 157append_todo_help () {
 158        gettext "
 159Commands:
 160p, pick = use commit
 161r, reword = use commit, but edit the commit message
 162e, edit = use commit, but stop for amending
 163s, squash = use commit, but meld into previous commit
 164f, fixup = like \"squash\", but discard this commit's log message
 165x, exec = run command (the rest of the line) using shell
 166d, drop = remove commit
 167
 168These lines can be re-ordered; they are executed from top to bottom.
 169" | git stripspace --comment-lines >>"$todo"
 170
 171        if test $(get_missing_commit_check_level) = error
 172        then
 173                gettext "
 174Do not remove any line. Use 'drop' explicitly to remove a commit.
 175" | git stripspace --comment-lines >>"$todo"
 176        else
 177                gettext "
 178If you remove a line here THAT COMMIT WILL BE LOST.
 179" | git stripspace --comment-lines >>"$todo"
 180        fi
 181}
 182
 183make_patch () {
 184        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 185        case "$sha1_and_parents" in
 186        ?*' '?*' '?*)
 187                git diff --cc $sha1_and_parents
 188                ;;
 189        ?*' '?*)
 190                git diff-tree -p "$1^!"
 191                ;;
 192        *)
 193                echo "Root commit"
 194                ;;
 195        esac > "$state_dir"/patch
 196        test -f "$msg" ||
 197                commit_message "$1" > "$msg"
 198        test -f "$author_script" ||
 199                get_author_ident_from_commit "$1" > "$author_script"
 200}
 201
 202die_with_patch () {
 203        echo "$1" > "$state_dir"/stopped-sha
 204        git update-ref REBASE_HEAD "$1"
 205        make_patch "$1"
 206        die "$2"
 207}
 208
 209exit_with_patch () {
 210        echo "$1" > "$state_dir"/stopped-sha
 211        git update-ref REBASE_HEAD "$1"
 212        make_patch $1
 213        git rev-parse --verify HEAD > "$amend"
 214        gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 215        warn "$(eval_gettext "\
 216You can amend the commit now, with
 217
 218        git commit --amend \$gpg_sign_opt_quoted
 219
 220Once you are satisfied with your changes, run
 221
 222        git rebase --continue")"
 223        warn
 224        exit $2
 225}
 226
 227die_abort () {
 228        apply_autostash
 229        rm -rf "$state_dir"
 230        die "$1"
 231}
 232
 233has_action () {
 234        test -n "$(git stripspace --strip-comments <"$1")"
 235}
 236
 237is_empty_commit() {
 238        tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
 239                sha1=$1
 240                die "$(eval_gettext "\$sha1: not a commit that can be picked")"
 241        }
 242        ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
 243                ptree=$empty_tree
 244        test "$tree" = "$ptree"
 245}
 246
 247is_merge_commit()
 248{
 249        git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
 250}
 251
 252# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
 253# GIT_AUTHOR_DATE exported from the current environment.
 254do_with_author () {
 255        (
 256                export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 257                "$@"
 258        )
 259}
 260
 261git_sequence_editor () {
 262        if test -z "$GIT_SEQUENCE_EDITOR"
 263        then
 264                GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
 265                if [ -z "$GIT_SEQUENCE_EDITOR" ]
 266                then
 267                        GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
 268                fi
 269        fi
 270
 271        eval "$GIT_SEQUENCE_EDITOR" '"$@"'
 272}
 273
 274pick_one () {
 275        ff=--ff
 276
 277        case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
 278        case "$force_rebase" in '') ;; ?*) ff= ;; esac
 279        output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
 280
 281        if is_empty_commit "$sha1"
 282        then
 283                empty_args="--allow-empty"
 284        fi
 285
 286        test -d "$rewritten" &&
 287                pick_one_preserving_merges "$@" && return
 288        output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
 289                        ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 290                        "$strategy_args" $empty_args $ff "$@"
 291
 292        # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
 293        # previous task so this commit is not lost.
 294        ret=$?
 295        case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
 296        return $ret
 297}
 298
 299pick_one_preserving_merges () {
 300        fast_forward=t
 301        case "$1" in
 302        -n)
 303                fast_forward=f
 304                sha1=$2
 305                ;;
 306        *)
 307                sha1=$1
 308                ;;
 309        esac
 310        sha1=$(git rev-parse $sha1)
 311
 312        if test -f "$state_dir"/current-commit && test "$fast_forward" = t
 313        then
 314                while read current_commit
 315                do
 316                        git rev-parse HEAD > "$rewritten"/$current_commit
 317                done <"$state_dir"/current-commit
 318                rm "$state_dir"/current-commit ||
 319                        die "$(gettext "Cannot write current commit's replacement sha1")"
 320        fi
 321
 322        echo $sha1 >> "$state_dir"/current-commit
 323
 324        # rewrite parents; if none were rewritten, we can fast-forward.
 325        new_parents=
 326        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 327        if test "$pend" = " "
 328        then
 329                pend=" root"
 330        fi
 331        while [ "$pend" != "" ]
 332        do
 333                p=$(expr "$pend" : ' \([^ ]*\)')
 334                pend="${pend# $p}"
 335
 336                if test -f "$rewritten"/$p
 337                then
 338                        new_p=$(cat "$rewritten"/$p)
 339
 340                        # If the todo reordered commits, and our parent is marked for
 341                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 342                        # drop it on top of the current HEAD
 343                        if test -z "$new_p"
 344                        then
 345                                new_p=$(git rev-parse HEAD)
 346                        fi
 347
 348                        test $p != $new_p && fast_forward=f
 349                        case "$new_parents" in
 350                        *$new_p*)
 351                                ;; # do nothing; that parent is already there
 352                        *)
 353                                new_parents="$new_parents $new_p"
 354                                ;;
 355                        esac
 356                else
 357                        if test -f "$dropped"/$p
 358                        then
 359                                fast_forward=f
 360                                replacement="$(cat "$dropped"/$p)"
 361                                test -z "$replacement" && replacement=root
 362                                pend=" $replacement$pend"
 363                        else
 364                                new_parents="$new_parents $p"
 365                        fi
 366                fi
 367        done
 368        case $fast_forward in
 369        t)
 370                output warn "$(eval_gettext "Fast-forward to \$sha1")"
 371                output git reset --hard $sha1 ||
 372                        die "$(eval_gettext "Cannot fast-forward to \$sha1")"
 373                ;;
 374        f)
 375                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 376
 377                if [ "$1" != "-n" ]
 378                then
 379                        # detach HEAD to current parent
 380                        output git checkout $first_parent 2> /dev/null ||
 381                                die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
 382                fi
 383
 384                case "$new_parents" in
 385                ' '*' '*)
 386                        test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
 387
 388                        # redo merge
 389                        author_script_content=$(get_author_ident_from_commit $sha1)
 390                        eval "$author_script_content"
 391                        msg_content="$(commit_message $sha1)"
 392                        # No point in merging the first parent, that's HEAD
 393                        new_parents=${new_parents# $first_parent}
 394                        merge_args="--no-log --no-ff"
 395                        if ! do_with_author output eval \
 396                                git merge ${gpg_sign_opt:+$(git rev-parse \
 397                                        --sq-quote "$gpg_sign_opt")} \
 398                                $allow_rerere_autoupdate "$merge_args" \
 399                                "$strategy_args" \
 400                                -m "$(git rev-parse --sq-quote "$msg_content")" \
 401                                "$new_parents"
 402                        then
 403                                printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
 404                                die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
 405                        fi
 406                        echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
 407                        ;;
 408                *)
 409                        output eval git cherry-pick $allow_rerere_autoupdate \
 410                                $allow_empty_message \
 411                                ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
 412                                "$strategy_args" "$@" ||
 413                                die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
 414                        ;;
 415                esac
 416                ;;
 417        esac
 418}
 419
 420this_nth_commit_message () {
 421        n=$1
 422        eval_gettext "This is the commit message #\${n}:"
 423}
 424
 425skip_nth_commit_message () {
 426        n=$1
 427        eval_gettext "The commit message #\${n} will be skipped:"
 428}
 429
 430update_squash_messages () {
 431        if test -f "$squash_msg"; then
 432                mv "$squash_msg" "$squash_msg".bak || exit
 433                count=$(($(sed -n \
 434                        -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
 435                        -e "q" < "$squash_msg".bak)+1))
 436                {
 437                        printf '%s\n' "$comment_char $(eval_ngettext \
 438                                "This is a combination of \$count commit." \
 439                                "This is a combination of \$count commits." \
 440                                $count)"
 441                        sed -e 1d -e '2,/^./{
 442                                /^$/d
 443                        }' <"$squash_msg".bak
 444                } >"$squash_msg"
 445        else
 446                commit_message HEAD >"$fixup_msg" ||
 447                die "$(eval_gettext "Cannot write \$fixup_msg")"
 448                count=2
 449                {
 450                        printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
 451                        printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
 452                        echo
 453                        cat "$fixup_msg"
 454                } >"$squash_msg"
 455        fi
 456        case $1 in
 457        squash)
 458                rm -f "$fixup_msg"
 459                echo
 460                printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
 461                echo
 462                commit_message $2
 463                ;;
 464        fixup)
 465                echo
 466                printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
 467                echo
 468                # Change the space after the comment character to TAB:
 469                commit_message $2 | git stripspace --comment-lines | sed -e 's/ /       /'
 470                ;;
 471        esac >>"$squash_msg"
 472}
 473
 474peek_next_command () {
 475        git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
 476}
 477
 478# A squash/fixup has failed.  Prepare the long version of the squash
 479# commit message, then die_with_patch.  This code path requires the
 480# user to edit the combined commit message for all commits that have
 481# been squashed/fixedup so far.  So also erase the old squash
 482# messages, effectively causing the combined commit to be used as the
 483# new basis for any further squash/fixups.  Args: sha1 rest
 484die_failed_squash() {
 485        sha1=$1
 486        rest=$2
 487        mv "$squash_msg" "$msg" || exit
 488        rm -f "$fixup_msg"
 489        cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
 490        warn
 491        warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
 492        die_with_patch $sha1 ""
 493}
 494
 495flush_rewritten_pending() {
 496        test -s "$rewritten_pending" || return
 497        newsha1="$(git rev-parse HEAD^0)"
 498        sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
 499        rm -f "$rewritten_pending"
 500}
 501
 502record_in_rewritten() {
 503        oldsha1="$(git rev-parse $1)"
 504        echo "$oldsha1" >> "$rewritten_pending"
 505
 506        case "$(peek_next_command)" in
 507        squash|s|fixup|f)
 508                ;;
 509        *)
 510                flush_rewritten_pending
 511                ;;
 512        esac
 513}
 514
 515do_pick () {
 516        sha1=$1
 517        rest=$2
 518        if test "$(git rev-parse HEAD)" = "$squash_onto"
 519        then
 520                # Set the correct commit message and author info on the
 521                # sentinel root before cherry-picking the original changes
 522                # without committing (-n).  Finally, update the sentinel again
 523                # to include these changes.  If the cherry-pick results in a
 524                # conflict, this means our behaviour is similar to a standard
 525                # failed cherry-pick during rebase, with a dirty index to
 526                # resolve before manually running git commit --amend then git
 527                # rebase --continue.
 528                git commit --allow-empty --allow-empty-message --amend \
 529                           --no-post-rewrite -n -q -C $sha1 &&
 530                        pick_one -n $sha1 &&
 531                        git commit --allow-empty --allow-empty-message \
 532                                   --amend --no-post-rewrite -n -q -C $sha1 \
 533                                   ${gpg_sign_opt:+"$gpg_sign_opt"} ||
 534                                   die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 535        else
 536                pick_one $sha1 ||
 537                        die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
 538        fi
 539}
 540
 541do_next () {
 542        rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
 543        read -r command sha1 rest < "$todo"
 544        case "$command" in
 545        "$comment_char"*|''|noop|drop|d)
 546                mark_action_done
 547                ;;
 548        "$cr")
 549                # Work around CR left by "read" (e.g. with Git for Windows' Bash).
 550                mark_action_done
 551                ;;
 552        pick|p)
 553                comment_for_reflog pick
 554
 555                mark_action_done
 556                do_pick $sha1 "$rest"
 557                record_in_rewritten $sha1
 558                ;;
 559        reword|r)
 560                comment_for_reflog reword
 561
 562                mark_action_done
 563                do_pick $sha1 "$rest"
 564                git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
 565                        $allow_empty_message || {
 566                        warn "$(eval_gettext "\
 567Could not amend commit after successfully picking \$sha1... \$rest
 568This is most likely due to an empty commit message, or the pre-commit hook
 569failed. If the pre-commit hook failed, you may need to resolve the issue before
 570you are able to reword the commit.")"
 571                        exit_with_patch $sha1 1
 572                }
 573                record_in_rewritten $sha1
 574                ;;
 575        edit|e)
 576                comment_for_reflog edit
 577
 578                mark_action_done
 579                do_pick $sha1 "$rest"
 580                sha1_abbrev=$(git rev-parse --short $sha1)
 581                warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
 582                exit_with_patch $sha1 0
 583                ;;
 584        squash|s|fixup|f)
 585                case "$command" in
 586                squash|s)
 587                        squash_style=squash
 588                        ;;
 589                fixup|f)
 590                        squash_style=fixup
 591                        ;;
 592                esac
 593                comment_for_reflog $squash_style
 594
 595                test -f "$done" && has_action "$done" ||
 596                        die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
 597
 598                mark_action_done
 599                update_squash_messages $squash_style $sha1
 600                author_script_content=$(get_author_ident_from_commit HEAD)
 601                echo "$author_script_content" > "$author_script"
 602                eval "$author_script_content"
 603                if ! pick_one -n $sha1
 604                then
 605                        git rev-parse --verify HEAD >"$amend"
 606                        die_failed_squash $sha1 "$rest"
 607                fi
 608                case "$(peek_next_command)" in
 609                squash|s|fixup|f)
 610                        # This is an intermediate commit; its message will only be
 611                        # used in case of trouble.  So use the long version:
 612                        do_with_author output git commit --amend --no-verify -F "$squash_msg" \
 613                                ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 614                                die_failed_squash $sha1 "$rest"
 615                        ;;
 616                *)
 617                        # This is the final command of this squash/fixup group
 618                        if test -f "$fixup_msg"
 619                        then
 620                                do_with_author git commit --amend --no-verify -F "$fixup_msg" \
 621                                        ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 622                                        die_failed_squash $sha1 "$rest"
 623                        else
 624                                cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
 625                                rm -f "$GIT_DIR"/MERGE_MSG
 626                                do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
 627                                        ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 628                                        die_failed_squash $sha1 "$rest"
 629                        fi
 630                        rm -f "$squash_msg" "$fixup_msg"
 631                        ;;
 632                esac
 633                record_in_rewritten $sha1
 634                ;;
 635        x|"exec")
 636                read -r command rest < "$todo"
 637                mark_action_done
 638                eval_gettextln "Executing: \$rest"
 639                "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
 640                status=$?
 641                # Run in subshell because require_clean_work_tree can die.
 642                dirty=f
 643                (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
 644                if test "$status" -ne 0
 645                then
 646                        warn "$(eval_gettext "Execution failed: \$rest")"
 647                        test "$dirty" = f ||
 648                                warn "$(gettext "and made changes to the index and/or the working tree")"
 649
 650                        warn "$(gettext "\
 651You can fix the problem, and then run
 652
 653        git rebase --continue")"
 654                        warn
 655                        if test $status -eq 127         # command not found
 656                        then
 657                                status=1
 658                        fi
 659                        exit "$status"
 660                elif test "$dirty" = t
 661                then
 662                        # TRANSLATORS: after these lines is a command to be issued by the user
 663                        warn "$(eval_gettext "\
 664Execution succeeded: \$rest
 665but left changes to the index and/or the working tree
 666Commit or stash your changes, and then run
 667
 668        git rebase --continue")"
 669                        warn
 670                        exit 1
 671                fi
 672                ;;
 673        *)
 674                warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
 675                fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
 676                if git rev-parse --verify -q "$sha1" >/dev/null
 677                then
 678                        die_with_patch $sha1 "$fixtodo"
 679                else
 680                        die "$fixtodo"
 681                fi
 682                ;;
 683        esac
 684        test -s "$todo" && return
 685
 686        comment_for_reflog finish &&
 687        newhead=$(git rev-parse HEAD) &&
 688        case $head_name in
 689        refs/*)
 690                message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
 691                git update-ref -m "$message" $head_name $newhead $orig_head &&
 692                git symbolic-ref \
 693                  -m "$GIT_REFLOG_ACTION: returning to $head_name" \
 694                  HEAD $head_name
 695                ;;
 696        esac && {
 697                test ! -f "$state_dir"/verbose ||
 698                        git diff-tree --stat $orig_head..HEAD
 699        } &&
 700        {
 701                test -s "$rewritten_list" &&
 702                git notes copy --for-rewrite=rebase < "$rewritten_list" ||
 703                true # we don't care if this copying failed
 704        } &&
 705        hook="$(git rev-parse --git-path hooks/post-rewrite)"
 706        if test -x "$hook" && test -s "$rewritten_list"; then
 707                "$hook" rebase < "$rewritten_list"
 708                true # we don't care if this hook failed
 709        fi &&
 710                warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
 711
 712        return 1 # not failure; just to break the do_rest loop
 713}
 714
 715# can only return 0, when the infinite loop breaks
 716do_rest () {
 717        while :
 718        do
 719                do_next || break
 720        done
 721}
 722
 723expand_todo_ids() {
 724        git rebase--helper --expand-ids
 725}
 726
 727collapse_todo_ids() {
 728        git rebase--helper --shorten-ids
 729}
 730
 731# Switch to the branch in $into and notify it in the reflog
 732checkout_onto () {
 733        GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
 734        output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
 735        git update-ref ORIG_HEAD $orig_head
 736}
 737
 738get_missing_commit_check_level () {
 739        check_level=$(git config --get rebase.missingCommitsCheck)
 740        check_level=${check_level:-ignore}
 741        # Don't be case sensitive
 742        printf '%s' "$check_level" | tr 'A-Z' 'a-z'
 743}
 744
 745# Initiate an action. If the cannot be any
 746# further action it  may exec a command
 747# or exit and not return.
 748#
 749# TODO: Consider a cleaner return model so it
 750# never exits and always return 0 if process
 751# is complete.
 752#
 753# Parameter 1 is the action to initiate.
 754#
 755# Returns 0 if the action was able to complete
 756# and if 1 if further processing is required.
 757initiate_action () {
 758        case "$1" in
 759        continue)
 760                if test ! -d "$rewritten"
 761                then
 762                        exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
 763                                --continue
 764                fi
 765                # do we have anything to commit?
 766                if git diff-index --cached --quiet HEAD --
 767                then
 768                        # Nothing to commit -- skip this commit
 769
 770                        test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
 771                        rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
 772                        die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
 773                else
 774                        if ! test -f "$author_script"
 775                        then
 776                                gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
 777                                die "$(eval_gettext "\
 778You have staged changes in your working tree.
 779If these changes are meant to be
 780squashed into the previous commit, run:
 781
 782  git commit --amend \$gpg_sign_opt_quoted
 783
 784If they are meant to go into a new commit, run:
 785
 786  git commit \$gpg_sign_opt_quoted
 787
 788In both cases, once you're done, continue with:
 789
 790  git rebase --continue
 791")"
 792                        fi
 793                        . "$author_script" ||
 794                                die "$(gettext "Error trying to find the author identity to amend commit")"
 795                        if test -f "$amend"
 796                        then
 797                                current_head=$(git rev-parse --verify HEAD)
 798                                test "$current_head" = $(cat "$amend") ||
 799                                die "$(gettext "\
 800You have uncommitted changes in your working tree. Please commit them
 801first and then run 'git rebase --continue' again.")"
 802                                do_with_author git commit --amend --no-verify -F "$msg" -e \
 803                                        ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 804                                        die "$(gettext "Could not commit staged changes.")"
 805                        else
 806                                do_with_author git commit --no-verify -F "$msg" -e \
 807                                        ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
 808                                        die "$(gettext "Could not commit staged changes.")"
 809                        fi
 810                fi
 811
 812                if test -r "$state_dir"/stopped-sha
 813                then
 814                        record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
 815                fi
 816
 817                require_clean_work_tree "rebase"
 818                do_rest
 819                return 0
 820                ;;
 821        skip)
 822                git rerere clear
 823
 824                if test ! -d "$rewritten"
 825                then
 826                        exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
 827                                --continue
 828                fi
 829                do_rest
 830                return 0
 831                ;;
 832        edit-todo)
 833                git stripspace --strip-comments <"$todo" >"$todo".new
 834                mv -f "$todo".new "$todo"
 835                collapse_todo_ids
 836                append_todo_help
 837                gettext "
 838You are editing the todo file of an ongoing interactive rebase.
 839To continue rebase after editing, run:
 840    git rebase --continue
 841
 842" | git stripspace --comment-lines >>"$todo"
 843
 844                git_sequence_editor "$todo" ||
 845                        die "$(gettext "Could not execute editor")"
 846                expand_todo_ids
 847
 848                exit
 849                ;;
 850        show-current-patch)
 851                exec git show REBASE_HEAD --
 852                ;;
 853        *)
 854                return 1 # continue
 855                ;;
 856        esac
 857}
 858
 859setup_reflog_action () {
 860        comment_for_reflog start
 861
 862        if test ! -z "$switch_to"
 863        then
 864                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
 865                output git checkout "$switch_to" -- ||
 866                        die "$(eval_gettext "Could not checkout \$switch_to")"
 867
 868                comment_for_reflog start
 869        fi
 870}
 871
 872init_basic_state () {
 873        orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
 874        mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
 875        rm -f "$(git rev-parse --git-path REBASE_HEAD)"
 876
 877        : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
 878        write_basic_state
 879}
 880
 881init_revisions_and_shortrevisions () {
 882        shorthead=$(git rev-parse --short $orig_head)
 883        shortonto=$(git rev-parse --short $onto)
 884        if test -z "$rebase_root"
 885                # this is now equivalent to ! -z "$upstream"
 886        then
 887                shortupstream=$(git rev-parse --short $upstream)
 888                revisions=$upstream...$orig_head
 889                shortrevisions=$shortupstream..$shorthead
 890        else
 891                revisions=$onto...$orig_head
 892                shortrevisions=$shorthead
 893        fi
 894}
 895
 896complete_action() {
 897        test -s "$todo" || echo noop >> "$todo"
 898        test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
 899        test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
 900
 901        todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
 902        todocount=${todocount##* }
 903
 904cat >>"$todo" <<EOF
 905
 906$comment_char $(eval_ngettext \
 907        "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
 908        "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
 909        "$todocount")
 910EOF
 911        append_todo_help
 912        gettext "
 913        However, if you remove everything, the rebase will be aborted.
 914
 915        " | git stripspace --comment-lines >>"$todo"
 916
 917        if test -z "$keep_empty"
 918        then
 919                printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
 920        fi
 921
 922
 923        has_action "$todo" ||
 924                return 2
 925
 926        cp "$todo" "$todo".backup
 927        collapse_todo_ids
 928        git_sequence_editor "$todo" ||
 929                die_abort "$(gettext "Could not execute editor")"
 930
 931        has_action "$todo" ||
 932                return 2
 933
 934        git rebase--helper --check-todo-list || {
 935                ret=$?
 936                checkout_onto
 937                exit $ret
 938        }
 939
 940        expand_todo_ids
 941
 942        test -d "$rewritten" || test -n "$force_rebase" ||
 943        onto="$(git rebase--helper --skip-unnecessary-picks)" ||
 944        die "Could not skip unnecessary pick commands"
 945
 946        checkout_onto
 947        if test -z "$rebase_root" && test ! -d "$rewritten"
 948        then
 949                require_clean_work_tree "rebase"
 950                exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
 951                        --continue
 952        fi
 953        do_rest
 954}
 955
 956git_rebase__interactive () {
 957        initiate_action "$action"
 958        ret=$?
 959        if test $ret = 0; then
 960                return 0
 961        fi
 962
 963        setup_reflog_action
 964        init_basic_state
 965
 966        init_revisions_and_shortrevisions
 967
 968        git rebase--helper --make-script ${keep_empty:+--keep-empty} \
 969                $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
 970        die "$(gettext "Could not generate todo list")"
 971
 972        complete_action
 973}
 974
 975git_rebase__interactive__preserve_merges () {
 976        initiate_action "$action"
 977        ret=$?
 978        if test $ret = 0; then
 979                return 0
 980        fi
 981
 982        setup_reflog_action
 983        init_basic_state
 984
 985        if test -z "$rebase_root"
 986        then
 987                mkdir "$rewritten" &&
 988                for c in $(git merge-base --all $orig_head $upstream)
 989                do
 990                        echo $onto > "$rewritten"/$c ||
 991                                die "$(gettext "Could not init rewritten commits")"
 992                done
 993        else
 994                mkdir "$rewritten" &&
 995                echo $onto > "$rewritten"/root ||
 996                        die "$(gettext "Could not init rewritten commits")"
 997        fi
 998
 999        init_revisions_and_shortrevisions
1000
1001        format=$(git config --get rebase.instructionFormat)
1002        # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1003        git rev-list --format="%m%H ${format:-%s}" \
1004                --reverse --left-right --topo-order \
1005                $revisions ${restrict_revision+^$restrict_revision} | \
1006                sed -n "s/^>//p" |
1007        while read -r sha1 rest
1008        do
1009                if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1010                then
1011                        comment_out="$comment_char "
1012                else
1013                        comment_out=
1014                fi
1015
1016                if test -z "$rebase_root"
1017                then
1018                        preserve=t
1019                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1020                        do
1021                                if test -f "$rewritten"/$p
1022                                then
1023                                        preserve=f
1024                                fi
1025                        done
1026                else
1027                        preserve=f
1028                fi
1029                if test f = "$preserve"
1030                then
1031                        touch "$rewritten"/$sha1
1032                        printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1033                fi
1034        done
1035
1036        # Watch for commits that been dropped by --cherry-pick
1037        mkdir "$dropped"
1038        # Save all non-cherry-picked changes
1039        git rev-list $revisions --left-right --cherry-pick | \
1040                sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1041        # Now all commits and note which ones are missing in
1042        # not-cherry-picks and hence being dropped
1043        git rev-list $revisions |
1044        while read rev
1045        do
1046                if test -f "$rewritten"/$rev &&
1047                   ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1048                then
1049                        # Use -f2 because if rev-list is telling us this commit is
1050                        # not worthwhile, we don't want to track its multiple heads,
1051                        # just the history of its first-parent for others that will
1052                        # be rebasing on top of it
1053                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1054                        sha1=$(git rev-list -1 $rev)
1055                        sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1056                        rm "$rewritten"/$rev
1057                fi
1058        done
1059
1060        complete_action
1061}